package net.minecraftforge.client.model;

import java.util.List;

import javax.vecmath.Matrix4f;

import net.minecraft.block.state.IBlockState;
import net.minecraft.client.renderer.block.model.BakedQuad;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms.TransformType;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.vertex.VertexFormat;
import net.minecraft.client.resources.model.IBakedModel;
import net.minecraft.util.EnumFacing;

import org.apache.commons.lang3.tuple.Pair;

import net.minecraft.client.renderer.block.model.ItemCameraTransforms.TransformType;
public interface ISmartBlockModel extends IBakedModel
{
    IBakedModel handleBlockState(IBlockState state);

    public static abstract class Wrapper implements ISmartBlockModel, IFlexibleBakedModel
    {
        protected final IFlexibleBakedModel parent;

        public Wrapper(IFlexibleBakedModel parent)
        {
            this.parent = parent;
        }

        public List<BakedQuad> func_177551_a(EnumFacing side)
        {
            return parent.func_177551_a(side);
        }

        public List<BakedQuad> func_177550_a()
        {
            return parent.func_177550_a();
        }

        public boolean func_177555_b()
        {
            return parent.func_177555_b();
        }

        public boolean func_177556_c()
        {
            return parent.func_177556_c();
        }

        public boolean func_177553_d()
        {
            return parent.func_177553_d();
        }

        public TextureAtlasSprite func_177554_e()
        {
            return parent.func_177554_e();
        }

        public ItemCameraTransforms func_177552_f()
        {
            return parent.func_177552_f();
        }

        public VertexFormat getFormat()
        {
            return parent.getFormat();
        }
    }

    public static abstract class PerspectiveWrapper extends Wrapper implements IPerspectiveAwareModel
    {
        protected final IPerspectiveAwareModel parent;

        public PerspectiveWrapper(IPerspectiveAwareModel parent)
        {
            super(parent);
            this.parent = parent;
        }

        public Pair<? extends IFlexibleBakedModel, Matrix4f> handlePerspective(TransformType type)
        {
            Pair<? extends IFlexibleBakedModel, Matrix4f> pair = parent.handlePerspective(type);
            return Pair.of(new ISmartBlockModel.Wrapper(pair.getLeft())
            {
                public IBakedModel handleBlockState(IBlockState state)
                {
                    return PerspectiveWrapper.this.handleBlockState(state);
                }
            }, pair.getRight());
        }
    }
}
